'hell1g
'DF6NM 06.10.00
'ex bmftwav1 27.4.99

DEFLNG A-Z

 path$ = "C:\Hell\"
 height = 8
 samplespercol = 4096& * 2
 'path$ = "..\fft\bmp_ff~1\hell\hell15\"
 'samplespercol = 4096& * 4
 'height = 15

 file1$ = "h" '"hell_"
 colsfnt = 8
 costablen = 1024
 fileblocksize = 4096

 DIM wt%(samplespercol - 1), ct%(costablen - 1)
 DIM s1%(samplespercol - 1), s2%(samplespercol - 1)
 DIM bmp%(colsfnt - 1, height - 1)
 DIM frq(height - 1), ph0(height - 1)
 out$ = STRING$(fileblocksize, 0)

 fbasehz! = 2020 '2.69 * 8

 aw! = .55 / SQR(height)
 samplerate = 11025
 cols = colsfnt + 1
 phmask = samplespercol - 1
 cshift = samplespercol \ costablen
 f0 = fbasehz! * samplespercol / samplerate '??
 
 FOR ny = 0 TO height - 1
  frq(ny) = 1 * ny + f0
  ph0(ny) = costablen * cshift * (ny * ny / 2 / height)
 NEXT ny

 GOSUB calcwavheader
 GOSUB calctables

 SCREEN 12
 IF height <> 15 THEN WIDTH , 60
 IF height = 15 THEN WIDTH , 30

 FOR nl = 32 TO 127'48 TO 49
 
  file$ = file1$ + RIGHT$("00" + HEX$(nl), 2) ' + ".wav"
  OPEN path$ + file$ FOR OUTPUT AS 2
  'PRINT #2, h2$;

  LOCATE 1, 1
  PRINT CHR$(nl)

  'bmp%(1, 0) = 1
  'bmp%(1, 7) = 1
 
  FOR x = 0 TO colsfnt - 1
   FOR y = 0 TO height - 1
    'bmp%(x, y) = 1
    bmp%(x, y) = -(POINT(x, height - 1 - y) <> 0)
   NEXT y
  NEXT x

  PRINT file$
  PRINT frq(0) * samplerate / samplespercol; "-";
  PRINT frq(height - 1) * samplerate / samplespercol; "Hz"
  'GOSUB printletterdata

  LINE (0, 240 + 127)-(639, 240 + 127), 2
  LINE (0, 240 - 128)-(639, 240 - 128), 2
 
  FOR x = 0 TO colsfnt
   FOR nt = 0 TO samplespercol - 1
    s1%(nt) = s2%(nt)
    s2%(nt) = 0
   NEXT nt
   IF x < colsfnt THEN
    FOR y = 0 TO height - 1
     ph = ph0(y)
     fr = frq(y)
     IF bmp%(x, y) > 0 THEN
      FOR nt = 0 TO samplespercol - 1
       ph = (ph + fr) AND phmask
       s2%(nt) = s2%(nt) + ct%(ph \ cshift)
      NEXT nt
     END IF
    NEXT y
   END IF
   
   FOR nt = 0 TO samplespercol - 1
    s1%(nt) = (s1%(nt) * wt%(nt) + s2%(nt) * wt%(samplespercol - 1 - nt)) \ 128
   NEXT nt
  
   fbmax = fileblocksize
   FOR nt0 = 0 TO samplespercol - 1 STEP fileblocksize
    IF nt0 + fbmax > samplespercol THEN fbmax = samplespercol - nt0
    FOR nt1 = 0 TO fbmax - 1
     s% = s1%(nt0 + nt1) + 128
     IF s% > 255 THEN s% = 255
     IF s% < 0 THEN s% = 0
     MID$(out$, nt1 + 1, 1) = CHR$(s%)
    NEXT nt1
    PRINT #2, out$;
   NEXT nt0

   FOR nt = 0 TO samplespercol - 1 STEP 4
    xdraw = (x * samplespercol + nt) * 640 / samples
    PSET (xdraw, 240 - s1%(nt)), 1 + (nl AND 7)
   NEXT nt

  NEXT x

  CLOSE 2
 NEXT nl
END


calcwavheader:
 samples = cols * samplespercol
 samples2 = 2 * ((samples + 1) \ 2)
 bits = 8
 channels = 1
 bytespersample = bits \ 8 * channels
 file2len = 44& + samples2 * bytespersample 'hdrlen=44, not 48

 h2$ = h2$ + "RIFF" + MKL$(file2len - 8)
 h2$ = h2$ + "WAVEfmt " + MKL$(16)
 h2$ = h2$ + MKI$(1) + MKI$(channels)
 h2$ = h2$ + MKL$(samplerate)
 h2$ = h2$ + MKL$(samplerate * bytespersample)
 h2$ = h2$ + MKI$(bytespersample) + MKI$(bits)
 h2$ = h2$ + "data" + MKL$(samples)

RETURN

calctables:
 pi! = 4! * ATN(1)

 ac! = 127
 FOR nt = 0 TO costablen - 1
  ct%(nt) = ac! * COS(nt * 2 * pi! / costablen)
 NEXT nt

 FOR nt = 0 TO samplespercol - 1
  wt%(nt) = aw! * 128 * (1 + COS(nt * pi! / samplespercol)) / 2
 NEXT nt
RETURN

printletterdata:
 FOR x = 0 TO colsfnt - 1
  PRINT
  FOR y = 0 TO height - 1
   PRINT bmp%(x, y);
  NEXT y
 NEXT x
 PRINT
RETURN

'********************

